// Number 15
// Druchenko Andrew
// List of units
//  Server: _15DataStruct,_15Prime,_15Unit1,_15Show;
//




unit _15Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ScktComp, Spin, _15Prime,_15DataStruct;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    Label3: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Label4: TLabel;
    Button2: TButton;
    Server: TServerSocket;
    Button3: TButton;
    mmLog: TMemo;
    Button4: TButton;
    GroupBox1: TGroupBox;
    lbFound: TLabel;
    lbClients: TLabel;
    Button5: TButton;
    Button6: TButton;
    procedure Button2Click(Sender: TObject);
    procedure ServerClientConnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerClientRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ServerClientDisconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ServerClientError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure Button6Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  Data:TDataPacket;
  ClientCount:integer; // A counter for clients.
                       //Increased each time client connects;
                       // and decreased when it was disconnected;

  LowerRange:Cardinal; //A current lower range for giving a new ranges to clients
  procedure Log(s:string);
  procedure UpdateStatus; //Updates the info in Status Area on the screen;


  end;

var
  Form1: TForm1;

implementation

uses _15Show;

{$R *.DFM}

procedure Tform1.log(s:string);
 begin
 mmlog.lines.add(s);
 end;

procedure Tform1.UpDateStatus;
 begin
 lbFound.caption:='Prime numbers found:'+inttostr(Data.PrimeList.count);
 lbClients.Caption:='Clients:'+inttostr(ClientCount);

 end;

procedure TForm1.Button2Click(Sender: TObject);
begin
// Server Starts HERE

 Server.Port:=SpinEdit1.value;
 Server.Open;
 Data.ID:=0;//Identifies that this is a server
 Data.Range1:=StrToInt(Edit2.text);
 Data.Range2:=StrToInt(Edit3.text);

 Log('Server started on port:'+IntToStr(SpinEdit1.value));
 Log('An interval to search for prime numbers:'+edit2.text+'-'+edit3.text);
// Inactivating edits
 edit2.enabled:=false;edit2.color:=clInactiveCaption;
 edit3.enabled:=false;edit3.color:=clInactiveCaption;
end;

procedure TForm1.ServerClientConnect(Sender: TObject;
  Socket: TCustomWinSocket);
var dt:TDataPacket;
    s:string;
    up:Cardinal;
begin

dt.PrimeList:=TstringList.create;
LowerRange:=LowerRange+1000;

inc(ClientCount);
log('Client connected:'+Inttostr(ClientCount));
dt.ID:=ClientCount;
dt.Range1:=lowerRange;
if (lowerRange+1000)>data.Range2 then
  dt.Range2:=data.Range2 else
    dt.Range2:=LowerRange+1000;

WriteToStr(dt,s);
//Sending a client info to start calculation

Server.Socket.Connections[ClientCount-1].SendText(s);


UpDateStatus;
dt.PrimeList.free;
end;

procedure TForm1.ServerClientRead(Sender: TObject;
  Socket: TCustomWinSocket);

var clData:TDataPacket;
    s:string;
    i:integer;
begin
clData.PrimeList:=TstringList.create;
// Getting an information from client;

s:=Socket.ReceiveText;
LoadFromStr(s,clData);

if clData.ID<>-1 then begin // this is a usual connection

  for i:=0 to clData.PrimeList.count-1 do
     Data.PrimeList.add(clData.PrimeList.strings[i]);

     clData.PrimeList.clear; //Clearing prime list
     //Changing Ranges
     clData.Range1:=lowerRange;

  if (lowerRange+1000)>data.Range2 then
     clData.Range2:=data.Range2 else   clData.Range2:=LowerRange+1000;
     LowerRange:=LowerRange+1000;

     WriteToStr(clData,s);

    // Sending a new task;
     Server.Socket.Connections[clData.ID-1].SendText(s);
     UpDateStatus;
     end else // and this is a connection when the client want to
         // get a full list of prime numbers;

     begin
     clData.PrimeList.assign(Data.PrimeList); //Copying a full list of prime numbers
                                // to send to the client;
     WriteToStr(clData,s);
     // Sending numbers to client;
     Server.Socket.Connections[clData.ID-1].SendText(s);
     end;


clData.PrimeList.free;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
Server.Close;
Log('Server stopped on port:'+IntToStr(Server.Port));
//Activating edits
edit2.enabled:=true;edit2.color:=clWindow;
edit3.enabled:=true;edit3.color:=clWindow;

end;

procedure TForm1.Button5Click(Sender: TObject);
begin
form2.showmodal;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
ClientCount:=0;
LowerRange:=data.Range1;
Data.PrimeList:=TStringList.create;
end;

procedure TForm1.ServerClientDisconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
log('Client disconnected:'+Inttostr(ClientCount));
dec(ClientCount);

UpDateStatus;
end;

procedure TForm1.ServerClientError(Sender: TObject;
  Socket: TCustomWinSocket; ErrorEvent: TErrorEvent;
  var ErrorCode: Integer);
begin
UpDateStatus;
log('Client error:'+inttostr(ErrorCode));
//socket.close;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
Data.PrimeList.SaveToFile('Primelist.txt');
end;

end.
